'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _assocPath = require('ramda/src/assocPath');

var _assocPath2 = _interopRequireDefault(_assocPath);

var _is = require('ramda/src/is');

var _is2 = _interopRequireDefault(_is);

var _path = require('ramda/src/path');

var _path2 = _interopRequireDefault(_path);

var _clone = require('./utils/clone');

var _clone2 = _interopRequireDefault(_clone);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var State = function () {
  function State(obj) {
    _classCallCheck(this, State);

    if ((typeof obj === 'undefined' ? 'undefined' : _typeof(obj)) !== 'object') {
      throw new TypeError(obj, 'is not an object');
    }

    this.obj = (0, _clone2.default)(obj);
    this['@@Plait/State'] = 1;
  }

  _createClass(State, [{
    key: 'clone',
    value: function clone() {
      return new State(this.obj);
    }
  }, {
    key: 'toObject',
    value: function toObject() {
      return (0, _clone2.default)(this.obj);
    }
  }, {
    key: 'set',
    value: function set(prop, val) {
      var newObj = {};

      newObj[prop] = val;

      return new State(Object.assign({}, this.obj, newObj));
    }
  }, {
    key: 'get',
    value: function get(prop) {
      var val = this.obj[prop];

      if ((0, _is2.default)(Object, val) && !val.hasOwnProperty('@@Plait/State')) {
        return (0, _clone2.default)(val);
      }

      return val;
    }
  }, {
    key: 'update',
    value: function update(prop, updater) {
      return this.set(prop, updater(this.get(prop)));
    }
  }, {
    key: 'setIn',
    value: function setIn(propPath, val) {
      var obj = (0, _assocPath2.default)(propPath, val, this.obj);

      return new State(obj);
    }
  }, {
    key: 'getIn',
    value: function getIn(propPath) {
      return (0, _path2.default)(propPath, this.obj);
    }
  }]);

  return State;
}();

exports.default = State;
module.exports = exports['default'];